From d041d2f9a6a8976179a2f9005e0d031dafd20de1 Mon Sep 17 00:00:00 2001
From: John Alway <thaleslv@yahoo.com>
Date: Sat, 7 Dec 2019 12:46:08 -0600
Subject: [PATCH] comctl32: Fix Treeview Expand using
 TVE_COLLAPSE|TVE_COLLAPSERESET

I used the test patch posted at the bugs link for bug #47641 to repair
 this.  The problem was that infoPtr->firstVisible was a null handle
 and threw an error in TREEVIEW_ComputeItemRect().

https://bugs.winehq.org/show_bug.cgi?id=47641
Signed-off-by: John Alway <thaleslv@yahoo.com>
---
 dlls/comctl32/treeview.c | 7 +++----
 1 file changed, 3 insertions(+), 4 deletions(-)

diff --git a/dlls/comctl32/treeview.c b/dlls/comctl32/treeview.c
index 06c4586fcd..070485efa6 100644
--- a/dlls/comctl32/treeview.c
+++ b/dlls/comctl32/treeview.c
@@ -3391,6 +3391,9 @@ TREEVIEW_Collapse(TREEVIEW_INFO *infoPtr, TREEVIEW_ITEM *item,
 	}
     }
 
+    TREEVIEW_SetFirstVisible(infoPtr,
+                             bSetFirstVisible ? item : infoPtr->firstVisible,
+                             TRUE);
     TREEVIEW_RecalculateVisibleOrder(infoPtr, item);
 
     if (nextItem)
@@ -3423,10 +3426,6 @@ TREEVIEW_Collapse(TREEVIEW_INFO *infoPtr, TREEVIEW_ITEM *item,
         InvalidateRect(infoPtr->hwnd, &scrollRect, TRUE);
     }
 
-    TREEVIEW_SetFirstVisible(infoPtr,
-                             bSetFirstVisible ? item : infoPtr->firstVisible,
-                             TRUE);
-
     return wasExpanded;
 }
 
-- 
2.24.0

